;========================================================
;main code for FLY cheat
;========================================================
ChangePlayerPosDivertedMethod:

cmp [FLY_MODE_BOOL],0
    jz NoChangePlayerPosDivertedMethod

mov edx,[esp+4]
mov eax,[LastXPostion_FLY]
mov [edx],eax
mov eax,[LastYPostion_FLY]
mov [edx+4h],eax
mov eax,[LastZPostion_FLY]
mov [edx+8h],eax

NoChangePlayerPosDivertedMethod:

jmp [TrueChangePlayerPosMethod]
;========================================================
TestForFlyModeKeys:
cmp [FLY_MODE_BOOL],0
    jz NoFlyModeKeys

cmp [IsInGame_BOOL],0
     jz NoFlyModeKeys
cmp [IsInConsole_BOOL],1
     jz NoFlyModeKeys

invoke GetTickCount
       mov edx,eax
       sub eax,[Key_Last_Recorded_Time]
       mov ecx,[UseFlyKeyDelay]
       cmp eax,ecx
	   jb EXITFLYMODEKEYS

       push eax
       mov [Key_Last_Recorded_Time],edx
       fild DWORD [esp]
       fmul [UseFlyKeyDelay_RECIPR]	;elapsedtime*(1/flykeydelay)

       fmul [UseFlySpeed]	;(elapsedtime/flykeydelay)*flyspeed
       fst [FlySpeedTemp]
       fmul [float_two]
       fstp [FlySpeedTemp_Fast]
       add esp,4

       mov edi,[KEY_LIST_ADDR]

       invoke GetAsyncKeyState,[edi+80]
       push MovePlayerForward_Fast
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+88]
       push MovePlayerForward_Slow
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+96]
       push MovePlayerBackward
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+104]
       push MovePlayerSidewaysLeft
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+112]
       push MovePlayerSidewaysRight
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+40]
       push MovePlayerUp
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+48]
       push MovePlayerDown
       call Modify_PositionValues

EXITFLYMODEKEYS:
NoFlyModeKeys:
ret
;========================================================
Modify_PositionValues:	;[esp+4]=proc to call, eax=most sign. bit set if go
test eax,80000000h
     jz NoModify_PositionValues

	mov eax,[LocationADDR]
	mov edx,[eax]
	mov edx,[edx+14h]

	push esi
	push edi
	lea esi,[edx+30h]
	mov edi,Temp_Fly_Buffer
	mov ecx,8
	rep movsd
	pop edi
	pop esi

	mov edx,Temp_Fly_Buffer3
	lea ecx,[Temp_Fly_Buffer+0Ch]	;most likely
	push edx
	push Temp_Fly_Buffer2  ;param 1 = dest for values (returned in eax)
	call DWORD [CONVERT_TO_FACING_PROC]	;2 params
	mov ecx,eax	       ;Temp_Fly_Buffer2

	call DWORD [esp+4]     ;MODIFY PLAYER POSITION VALUES

NoModify_PositionValues:
ret 4
;=========
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]

	push esi
	lea esi,[edx+30h]
	mov edi,Temp_Fly_Buffer
	mov ecx,8
	rep movsd
	pop esi

	mov eax,[edx]
	push 0
	mov ecx,edx
	push Temp_Fly_Buffer
	call DWORD [eax+38h]	;update position
ret 4

;========================================================
;code and calculations for FLY cheat
;========================================================
MovePlayerForward_Fast:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [FlySpeedTemp_Fast]
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [FlySpeedTemp_Fast] ;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerForward_Slow:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [FlySpeedTemp]
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [FlySpeedTemp]	 ;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerBackward:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [FlySpeedTemp]
	fsubr [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [FlySpeedTemp]	 ;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fsubr DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerSidewaysLeft:
	;ecx=pointer to 3 facing values x,y,z

	fld DWORD [ecx+4]	  ;Y facing value
	fmul [pidivtwo]
	fsin
	fmul [FlySpeedTemp]
	fsubr DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx]       ;X facing value
	fmul [pidivtwo]
	fsin
	fmul [FlySpeedTemp]
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
ret

;========================================================
MovePlayerSidewaysRight:
	;ecx=pointer to 3 facing values x,y,z

	fld DWORD [ecx+4]	  ;Y facing value
	fmul [pidivtwo]
	fsin
	fmul [FlySpeedTemp]
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx]       ;X facing value
	fmul [pidivtwo]
	fsin
	fmul [FlySpeedTemp]
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
ret
;========================================================
MovePlayerUp:
	fld [LastZPostion_FLY]
	fadd [FlySpeedTemp]
	fstp [LastZPostion_FLY]
ret
;========================================================
MovePlayerDown:
	fld [LastZPostion_FLY]
	fsub [FlySpeedTemp]
	fstp [LastZPostion_FLY]
ret
;========================================================
