;============================================================
;VALUES FOR ATYPEX.DLL AND INCLUDED SOURCE FILES
;============================================================

;====================================================================
;GENERAL VALUES
;====================================================================
;text display vertical coordinates
FACE_FLOATS_MSG        equ     00h
TIME_STAMP_MSG	       equ     2Eh
SHOW_DRAW_DIST_MSG     equ     3Eh
KEY_STATE_MSG	       equ     4Eh
ERROR_LOG_MSG_VERT     equ     5Eh
Base_CAnimal_display   equ     70h

DotBlinkSpeed		equ	400

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

value_int		equ	3	;ID types from T-Script
value_float		equ	4
value_string		equ	5
value_group		equ	6
value_bool		equ	1

;T-SCRIPT ENTRIES
;THESE ARE THE DISPLACEMENT VALUES SPECIFIC TO T-SCRIPT ENTRIES
;THAT ARE ADDED TO THE BASE ID TABLE ADDRESS AND PASSED TO THE
;GetEntryValueProc FUNCTION

Ammo		equ	027F8h
AltAmmoCount	equ	02818h
Frame		equ	014D0h
Interval	equ	012D8h
LoopCount	equ	00FA8h
MaxAmmo 	equ	02800h
Target		equ	003D8h ;doesn't work well
Sample		equ	00F48h
Speed		equ	02A18h
XPos		equ	00FE0h
YPos		equ	00FE8h
X		equ	011F8h
Y		equ	01200h
WakeUp		equ	02A58h
Sleep		equ	02A60h
ActGetOut	equ	(052Eh*8)+2A8h
HitPoints	equ	00408h
MaxHitPoints	equ	00410h

DOES_NOT_APPLY_TO_EXE	equ	0

default_fast_fly_speed		equ	0.400000
default_normal_fly_speed	equ	0.200000
default_key_fly_delay		equ	10

canimal_emos_count	equ  (canimal_emos_text_table_end-canimal_emos_text_table)/4

;====================================================================
;DIRECTX
;====================================================================
;Some DirectX structures and constants, not necessarily used

DDLOCK_WAIT	=	00000001

struc DDCOLORKEY  {
  .dwColorSpaceLowValue  dd ?
  .dwColorSpaceHighValue dd ?
}

struc DDPIXELFORMAT {
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwFourCC	   dd ?
  label .dwYUVBitCount	   dword
  label .dwZBufferBitDepth dword
  label .dwAlphaBitDepth   dword
	.dwRGBBitCount	   dd ?
  label .dwYBitMask	   dword
	.dwRBitMask	   dd ?
  label .dwUBitMask	   dword
	.dwGBitMask	   dd ?
  label .dwVBitMask	   dword
	.dwBBitMask	   dd ?
  label .dwYUVAlphaBitMask dword
  label .dwRGBZBitMask	   dword
  label .dwYUVZBitMask	   dword
	.dwRGBAlphaBitMask dd ?
}

struc DDSCAPS2 {
  .dwCaps  dd ?
  .dwCaps2 dd ?
  .dwCaps3 dd ?
  .dwCaps4 dd ?
}

struc DDSURFACEDESC2 {
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwHeight	   dd ?
	.dwWidth	   dd ?
  label .dwLinearSize	   dword
	.lPitch 	   dd ?
	.dwBackBufferCount dd ?
  label .dwZBufferBitDepth dword
  label .dwRefreshRate	   dword
	.dwMipMapCount	   dd ?
	.dwAlphaBitDepth   dd ?
	.dwReserved	   dd ?
	.lpSurface	   dd ?
	.ddckCKDestOverlay DDCOLORKEY
	.ddckCKDestBlt	   DDCOLORKEY
	.ddckCKSrcOverlay  DDCOLORKEY
	.ddckCKSrcBlt	   DDCOLORKEY
	.ddpfPixelFormat   DDPIXELFORMAT
	.ddsCaps	   DDSCAPS2
}

;====================================================================
;POSSIBLE CONFLICT VALUES
;====================================================================
;This/these current value(s) isn't/aren't currently implemented
;in FASM's include library at this time, but may be in the future
;and cause conflicts. Delete if this happens to be the case.

DIB_RGB_COLORS		equ 0	;remove if conflict with include files
